{-# LANGUAGE DeriveAnyClass #-}
{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DeriveLift #-}
module Parsers.Brainfuck.Types where

import Control.DeepSeq (NFData)
import Data.Eq (Eq)
import Data.Ord (Ord)
import GHC.Generics (Generic)
import Text.Show (Show(..))
import qualified Language.Haskell.TH.Syntax as TH

data Instruction
  = Forward
  | Backward
  | Increment
  | Decrement
  | Input
  | Output
  | Loop [Instruction]
  deriving (Show, Eq, Ord, TH.Lift, Generic, NFData)
